SystemOrganization addCategory: #'Rizel-Spy-Profiler'!
SystemOrganization addCategory: #'Rizel-Spy-Profiler-Tests'!

Profiler subclass: #RzProfilerSpy
	instanceVariableNames: 'inputs dimensions countMessages iterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!RzProfilerSpy class methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 19:36'!
gatherForPackages: aCollection
	^ self new gatherForPackages: aCollection.! !

!RzProfilerSpy class methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 11/19/2012 12:11'!
getNumberOfCalls
	<primitive: 'primitiveGetSentMessages' module: ''>
	
	^ self primitiveFailed ! !

!RzProfilerSpy class methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 19:37'!
installOnPackageNames: aCollection 
	aCollection do:[ :pn| self installOnPackageNamed: pn].! !

!RzProfilerSpy class methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:06'!
numberOfCallsIn: aBlock
"
	self new numberOfCallsIn: [ 10 yourself; yourself; yourself ]
	self new numberOfCallsIn: [  10  log ]
	self new numberOfCallsIn: [ '1' , '2']
	
	self new numberOfCallsIn: [ '1' , '2']
	
	|s|
	s := Set new.
	Compteur new numberOfCallsIn: [ 1000 timesRepeat: [s add: Object new]]   
	56259
	56415
	54383 55997 56165
"	
	| t |
	t := self resetNumberOfCalls.
	aBlock value.
	"-3 is the number of messages sent by an empty block. "
	^ (self getNumberOfCalls - 3) / 2! !

!RzProfilerSpy class methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 20:53'!
packageNamesOf: aConfigurationClass
	
	^ aConfigurationClass project currentVersion
		packages  collect:[ :p |  p name].! !

!RzProfilerSpy class methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 20:55'!
profile: aBlock usingConfiguration: aConfigurationClass
	| messageTally tally profiler packageSpy packageNames|
	packageNames := self packageNamesOf: aConfigurationClass.
	Transcript show: 'profiling...'; cr.
	[
		self installOnPackageNames: packageNames.
		profiler := self gatherForPackages: packageNames.
		profiler beforeProfiling.
		aBlock value.
		profiler afterProfiling. ]
	ensure: [ self removeFromPackageNames: packageNames ].
	Transcript show: 'ended...'; cr.
	profiler setIfNecessaryTimeAndCallGraphFrom: aBlock.
	profiler checkInvariant.
	
	^ profiler

	
	
	! !

!RzProfilerSpy class methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 19:39'!
removeFromPackageNames: aCollection 
	aCollection do:[ :pn| self removeFromPackageNamed: pn].! !

!RzProfilerSpy class methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 11/19/2012 12:12'!
resetNumberOfCalls
	<primitive: 'primitiveResetSentMessages' module: ''>
	
	^ self primitiveFailed ! !

!RzProfilerSpy class methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:19'!
spyClassForPackage
	^ RzPackageSpy! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:01'!
allCoveredClasses
	^ self allClasses select: #isCovered! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:02'!
allCoveredMethods
	^ self allMethods select: #isCovered! !

!RzProfilerSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 01:26'!
beforeProfiling
	
	self countMessages
		ifTrue: [
			self resetNumberOfLookedUpMethods; resetNumberOfCalls]! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/24/2012 23:55'!
countMessages
	^ countMessages.! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/24/2012 23:53'!
countMessages: aBoolean
	countMessages := aBoolean.! !

!RzProfilerSpy methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 01:09'!
coverage
	(self allMethods isEmpty ) ifTrue: [ ^ 0].
	^ (self allCoveredMethods size) / (self allMethods size).! !

!RzProfilerSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 19:35'!
gatherForPackages: aCollection
	"Return a profiler"
	
	| classType packageInfos |

	packageInfos := (PackageInfo allPackages select: [:p | aCollection includes: (p name) ]).

	packageInfos do: [ :pak | 
		| class package |
		package := self class spyClassForPackage new.
		package packageName: pak packageName.
		self addPackage: package.

		(pak classesAndMetaClasses reject: #isTrait) do: [:cls|
			class := self spyForClass: cls.
			class packageSpy: package.
			package classAt: cls name asSymbol put: class ] ].

	^ self! !

!RzProfilerSpy methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
getNumberOfCalls
	^ self class getNumberOfCalls! !

!RzProfilerSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 9/21/2012 16:30'!
getTimeAndCallGraph
	^ false.! !

!RzProfilerSpy methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 9/21/2012 16:32'!
initialize
	super initialize.
	totalExecutionTime := 1.
	countMessages := true.
	iterations := 1.! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/24/2012 23:53'!
iterations: aNumber
	iterations := aNumber.! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:02'!
numberOfCalls
	^ self allMethods inject: 0 into: [ :sum :el | sum + el numberOfEmittedCalls ]! !

!RzProfilerSpy methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
numberOfCallsIn: aBlock
	^ self class numberOfCallsIn: aBlock! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:03'!
numberOfEmittedCalls
	^ self allMethods inject: 0 into: [ :sum :el | sum + el numberOfEmittedCalls ]! !

!RzProfilerSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:03'!
registryName
	^ #MProfiler! !

!RzProfilerSpy methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
resetNumberOfCalls
	^ self class resetNumberOfCalls! !

!RzProfilerSpy methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
resetNumberOfLookedUpMethods
	<primitive: 555>
	self primitiveFailed! !

!RzProfilerSpy methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
setNumberOfEmittedCalls: integer
	<primitive: 558>
	self primitiveFailed! !

!RzProfilerSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:05'!
setTimeInfoFromTally: aTally parents: tallies
	
	| sons mClass method newTallies callerTally parentTally callerMethod callerClass |

	mClass := self classAt: aTally method methodClass name ifNone: [nil].
	mClass ifNotNil: [
		method := mClass localMethodAt: aTally method selector ifAbsent: [nil].
		method ifNotNilDo: [:e | 
			method useTime: aTally parents: tallies.]].

	sons := aTally receivers.
	newTallies := tallies , {aTally}.
	sons do: [:e | self setTimeInfoFromTally: e parents: newTallies].
! !

!RzProfilerSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 00:49'!
tallyOn: aBlock 
	| tally |
	tally := Sampling new.
	tally
		spyEvery: 1
		on: [iterations timesRepeat: aBlock].
	^ tally! !

!RzProfilerSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:42'!
totalExecutionTime
	^ totalExecutionTime ! !

MethodSpy subclass: #RzMethodSpy
	instanceVariableNames: 'numberOfExecutions numberOfCalls depthMax depthMin isRelevantCache copySourceCode tally numberOfCallsMajor isTestMethod'
	classVariableNames: 'CurrentMethod'
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!RzMethodSpy class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:20'!
resetCallerMethod
	CallerMethod := nil! !

!RzMethodSpy methodsFor: 'accessing' stamp: 'JPSA 6/18/2012 21:37'!
className
	^ self classSpy className.! !

!RzMethodSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 23:06'!
copySourceCode
	^ copySourceCode ! !

!RzMethodSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
depthMax 
	^ depthMax ! !

!RzMethodSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
depthMin 
	^ depthMin! !

!RzMethodSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/10/2012 15:10'!
executionTime: aNumber
	super executionTime: aNumber.
	tally := true.! !

!RzMethodSpy methodsFor: 'support private' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:08'!
fractionOfTotalExecution
	^ (self numberOfEmittedCalls / self profiler numberOfCalls) asFloat ! !

!RzMethodSpy methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:09'!
getNumberOfCalls
	<primitive: 556>
	self primitiveFailed! !

!RzMethodSpy methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:09'!
getNumberOfEmittedCallsMajor
	<primitive: 560>
	self primitiveFailed! !

!RzMethodSpy methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:09'!
getNumberOfLookedUpMethods
	<primitive: 554>
	self primitiveFailed! !

!RzMethodSpy methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
getNumberOfLookedUpMethodsMajor
	<primitive: 559>
	self primitiveFailed! !

!RzMethodSpy methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
hasAlwaysTheSameReturnValue
	^ (self returnValueTable select: #notNil) asSet size = 1! !

!RzMethodSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:10'!
incomingAndOutgoingCallClass
	^ IdentitySet! !

!RzMethodSpy methodsFor: 'support private' stamp: 'JuanPabloSandovalA 6/9/2012 16:47'!
increaseNumberOfCalls

	numberOfCalls := numberOfCalls + 1! !

!RzMethodSpy methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:31'!
initialize
	super initialize.
	executionTime := 0.
	numberOfCalls := 0.
	depthMin := 0.
	depthMax := 0.
	tally := false.
	numberOfExecutions := 0.
	numberOfCallsMajor := 0.! !

!RzMethodSpy methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 22:11'!
isCovered
	^ true! !

!RzMethodSpy methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
isLeaf
	^ self outgoingCalls isEmpty! !

!RzMethodSpy methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
isNotLeaf
	^ self isLeaf not! !

!RzMethodSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/24/2012 23:43'!
isTestMethod
	^ isTestMethod.! !

!RzMethodSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:08'!
numberOfCalls
	^ numberOfCalls + (numberOfCallsMajor * SmallInteger maxVal)! !

!RzMethodSpy methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:08'!
numberOfEmittedCalls
	^ numberOfCalls + (numberOfCallsMajor * SmallInteger maxVal)! !

!RzMethodSpy methodsFor: 'metrics' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 22:02'!
numberOfExecutions
	^ numberOfExecutions.! !

!RzMethodSpy methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfIncomingCalls
	^ self incomingCalls size! !

!RzMethodSpy methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfOutgoingCalls
	^ self outgoingCalls size! !

!RzMethodSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 01:27'!
originalMethod: aCompiledMethod 
	super originalMethod: aCompiledMethod copy.
	copySourceCode := self sourceCode copy.
	isTestMethod := self isTestMethod.! !

!RzMethodSpy methodsFor: 'printing' stamp: 'JuanPabloSandovalA 6/9/2012 16:50'!
printOn: stream 
	super printOn: stream.
	stream nextPut: $ .
	stream nextPutAll: executionTime printString.
	stream nextPutAll: ' ms '.
	self profiler ifNil: [ ^ self ].
	self profiler totalExecutionTime ifNil: [ ^ self ].

	self profiler totalExecutionTime > 0
		ifTrue: [ 
			stream nextPut: $(.
			stream nextPutAll: (executionTime * 100 / self profiler totalExecutionTime) asInteger printString.
			stream nextPut: $%.
			stream nextPut: $) ].
	
	stream nextPutAll: ('<n>executed <1p> time<2s> <n>' expandMacrosWithArguments: {self numberOfCalls . (self numberOfCalls > 1) ifTrue: ['s']ifFalse: [''] }).
"	self isRelevant 
		ifTrue: [ stream cr. stream nextPutAll: ' above time threshold' ].
"		
	self performSideEffect
		ifFalse: [ stream cr. stream nextPutAll: ' performs no side effect' ].
		
"	self hasSameArgumentsPerReceiver 
		ifTrue: [ stream cr. stream nextPutAll: ' and has same arguments per receiver' ].
"
	stream cr.
	stream nextPutAll: 'invoked on at least '.
	stream nextPutAll: self numberOfDifferentReceiversAtLeast printString.
	stream nextPutAll: ' receiver'.
	self numberOfDifferentReceiversAtLeast > 1
		ifTrue: [ stream nextPut: $s ].

	self hasSameReturnValuePerReceiver 
		ifTrue: [ stream cr; nextPutAll: 'same return value per receiver'].

	! !

!RzMethodSpy methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
resetNumberOfCalls
	<primitive: 557>
	self primitiveFailed! !

!RzMethodSpy methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
resetNumberOfLookedUpMethods
	<primitive: 555>
	self primitiveFailed! !

!RzMethodSpy methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:11'!
run: aSelector with: aListOfArguments in: aReceiver 
	| v oldNumberOfEmittedCalls oldNumberOfEmittedCallsMajor previousMethod|
	
	[
	numberOfExecutions := numberOfExecutions + 1.
	CurrentMethod
		ifNotNil: [ 
			self addIncomingCalls: CurrentMethod.
			CurrentMethod addOutgoingCalls: self ].
	previousMethod := CurrentMethod.
	CurrentMethod := self.

	self profiler countMessages ifTrue: [
		oldNumberOfEmittedCallsMajor := self getNumberOfEmittedCallsMajor.
		oldNumberOfEmittedCalls := self getNumberOfCalls]
	] on: Error do: [].
			
	[v := super run: aSelector with: aListOfArguments in: aReceiver.]
	ensure:[ CurrentMethod := previousMethod.].
				
	[
	self profiler countMessages ifTrue:[
		numberOfCalls := self getNumberOfCalls - oldNumberOfEmittedCalls + 
								numberOfCalls - 5.
		numberOfCallsMajor := self getNumberOfEmittedCallsMajor -
								 oldNumberOfEmittedCallsMajor + numberOfCallsMajor].
	] on: Error do: [].
		
	^ v! !

!RzMethodSpy methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
setNumberOfEmittedCalls: integer
	<primitive: 558>
	self primitiveFailed! !

AbstractSpyTest subclass: #RzProfilerSpyTest
	instanceVariableNames: ''
	classVariableNames: 'cache'
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler-Tests'!

!RzProfilerSpyTest commentStamp: '<historical>' prior: 0!
A RzProfilerSpyTest is a test class for testing the behavior of RzProfilerSpy!

!RzProfilerSpyTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:34'!
cache
	cache ifNil:[ 
		Transcript show:'2'.
		cache := 2].
	^ cache! !

!RzProfilerSpyTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:33'!
cache: anObject
	cache := anObject! !

!RzProfilerSpyTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:33'!
reset
	cache := nil.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:53'!
buildPendrive
	|pendrive mp3s mp4s texts images|
	pendrive := RSPenDrive new.
	mp3s := RSDirectory new.
	mp3s add: (RSMP3File named:'MP3A' size:10).
	mp3s add: (RSMP3File named:'MP3B' size:10).
	mp3s add: (RSMP3File named:'MP3C' size:10).
	mp3s add: (RSMP3File named:'MP3D' size:10).
	mp3s add: (RSMP3File named:'MP3E' size:10).
	mp3s add: (RSMP3File named:'MP3F' size:10).
	
	mp4s := RSDirectory new.	
	mp4s add: (RSMP3File named:'MP4A' size:10).
	mp4s add: (RSMP3File named:'MP4B' size:10).
	mp4s add: (RSMP3File named:'MP4C' size:10).
	mp4s add: (RSMP3File named:'MP4D' size:10).
	mp4s add: (RSMP3File named:'MP4E' size:10).
	mp4s add: (RSMP3File named:'MP4F' size:10).
	
	texts := RSDirectory new.
	texts add: (RSTextFile named:'TextA' size:10).
	texts add: (RSTextFile named:'TextB' size:10).
	texts add: (RSTextFile named:'TextC' size:10).
	texts add: (RSTextFile named:'TextD' size:10).
	texts add: (RSTextFile named:'TextE' size:10).
	texts add: (RSTextFile named:'TextF' size:10).
	
	images := RSDirectory new.
	images add: (RSImageFile named:'ImageA').
	images add: (RSImageFile named:'ImageB').
	images add: (RSImageFile named:'ImageC').
	images add: (RSImageFile named:'ImageD').
	images add: (RSImageFile named:'ImageE').
	images add: (RSImageFile named:'ImageF').
	
	pendrive add: mp3s.
	pendrive add: mp4s.	
	pendrive add: texts.
	pendrive add: images.
	
	^ pendrive.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:30'!
testBasic
	"
	self new testBasic
	"
	|profile|
	
	profile := RzProfilerSpy profile: [
		RSImageFile named: 'TestImage.jpg'.
		] inClassCategory:'Rizel-Test-Scenario'.

	self assert: (profile packages size = 1).	
	self assert: (profile allMethods notEmpty).	! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 19:41'!
testCofigurationCategories
	! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 01:08'!
testCoverage
	"
	self new testBasic
	"
	|profile image time|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		] inClassCategory:'Rizel-Test-Scenario'.
	time := (profile>>#RSImageFile>>#open) executionTime.

	self assert: (profile allCoveredClasses size > 1).
	self assert: (profile allCoveredMethods size > 1).
	self assert: (profile coverage > 0).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:29'!
testExecutionTime
	"
	self new testBasic
	"
	|profile image time|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		] inClassCategory:'Rizel-Test-Scenario'.
	time := (profile>>#RSImageFile>>#open) executionTime.
	"should be 200 milliseconds"
	"instrumentation cost 20% aprox"
	self assert: ( time > 190).	
	self assert: ( time < 250).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:51'!
testExecutionTime2
	"
	self new testBasic
	"
	|profile image mp3 time time2|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	mp3 := RSMP3File named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		mp3 open.
		] inClassCategory:'Rizel-Test-Scenario'.
	time := (profile>>#RSImageFile>>#open) executionTime.
	time2 := (profile>>#RSMP3File>>#open) executionTime.
	"this is not good enough"
	self assert: ( time > 190).	
	self assert: ( time < 250).
	self assert: ( time2 > 200).	
	self assert: ( time2 < 300).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:33'!
testNumberOfExecution
	"
	self new testBasic
	"
	|profile image|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		10 timesRepeat: [image size].
		] inClassCategory:'Rizel-Test-Scenario'.

	self assert: ( (profile>>#RSFile>>#size) numberOfExecutions =10).	
	! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:10'!
testScenario
	self buildPendrive.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:14'!
testScenario2
	|pen|
	pen := self buildPendrive.
	
	self assert: ((pen collect:[ :file |  file class = RSTextFile]) size = 6).! !

PackageSpy subclass: #RzPackageSpy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!RzPackageSpy class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:18'!
spyClassForClass
	^ RzClassSpy! !

ClassSpy subclass: #RzClassSpy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!RzClassSpy class methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:06'!
isCovered
	^ self methods anySatisfy: #isCovered! !

!RzClassSpy class methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:19'!
spyClassForMethod
	^ RzMethodSpy! !

!RzClassSpy methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:43'!
isCovered
	^ self allMethods anySatisfy: #isCovered! !
